.TH RIGEL_FileFormat 3 "2006-03-10" Unix Libraries



.SH NAME
.I  - Instructions manual
.PD 0
.P
.PD
----------------------


. RIGEL: Representation-Independant Genetic Engine Library
. Copyright (C) 2000-2005 Yann LANDRIN-SCHWEITZER, a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER, a.k.a. Varkhan
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Interface format structure



.PD 1
.P
.PD
.SS Function RIGEL_FReadParameters
.PD 0


.I unsigned
.I long
.B RIGEL_FReadParameters
(
.I RIGEL_Parameters
.B param
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Reads updates to a parameter set from an input stream.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to update
.IP "" 0
.IP _ 2
.I os
	: input stream to read from
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occured
.IP "" 0
else the updated parameter set.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
any error returned by the fread LibC function
.RE
.PD 1
.P
.PD


.B
	Note
.RS
This method behaves in the same way as 'RIGEL_ReadParameters'.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_FWriteParameters
.PD 0


.I unsigned
.I long
.B RIGEL_FWriteParameters
(
.I RIGEL_Parameters
.B param
,
.I FILE
.B *
.B os
) ;

.PD 1
.P
.PD
Writes a parameter set onto an output stream.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to write
.IP "" 0
.IP _ 2
.I os
	: output stream to write onto
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if some error occured
.IP "" 0
else the number of characters written on 'os'.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
any error returned by the fwrite LibC function
.RE
.PD 1
.P
.PD


.B
	Note
.RS
This method behaves in the same way as 'RIGEL_WriteParameters'.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_FileLoad
.PD 0


.I RIGEL_Population
.B RIGEL_FileLoad
(
.I RIGEL_Interface
.B iface
,
.I RIGEL_Parameters
.B param
,
.I char
.B *
.B file
) ;

.PD 1
.P
.PD
.

.B
	Args
.RS
iface
param
file
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if 
.IP "" 0
else .
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_FileSave
.PD 0


.I unsigned
.I long
.B RIGEL_FileSave
(
.I RIGEL_Population
.B pop
,
.I char
.B *
.B file
) ;

.PD 1
.P
.PD
.

.B
	Args
.RS
pop
file
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if 
.IP "" 0
else .
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
.
.RE
.PD 1
.P
.PD







