.TH RIGEL_Parameters 3 "2006-03-04" Unix Libraries



.SH NAME
.I Genetic parameters - Instructions manual
.PD 0
.P
.PD
----------------------------------------


. RIGEL: Representation-Independant Genetic Engine Library
. Copyright (C) 2000-2005 Yann LANDRIN-SCHWEITZER, a.k.a. Varkhan
. 
. 
. This library is free software;  you can redistribute it and/or modify it
. under  the terms of the  GNU Lesser General Public License  as published
. by the  Free Software Foundation;  either version 2.1 of the License, or
. (at your option) any later version.
. 
. This  library  is  distributed  in  the hope that it will be useful, but
. WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of
. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
. General Public License for more details.
. 
. You should have received a copy of the GNU Lesser General Public License
. along with this library;  if not, write to the Free Software Foundation,
. Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
. 
. 
. Author:   Yann LANDRIN-SCHWEITZER, a.k.a. Varkhan
. Contact:  varkhan@varkhan.net
. Homepage: http://www.varkhan.net/




.SH Genetic parameters flags



.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_SORTDESC
.PD 0
RIGEL_PARAM_SORTDESC
.PD 1
.P
.PD
Set the optimization model to minimization (using population sorting in descending order).

.B
	Note
.RS
By defaults, RIGEL maximizes evaluations. Setting this flag makes RIGEL minimize evaluations.
.RE
.PD 1
.P
.PD







.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_SELRANKG
.PD 0
RIGEL_PARAM_SELRANKG
.PD 1
.P
.PD
Uses ranking as parent selection method.




.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_SELTOURN
.PD 0
RIGEL_PARAM_SELTOURN
.PD 1
.P
.PD
Uses tournament as parent selection method.




.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_SELECTOR
.PD 0
RIGEL_PARAM_SELECTOR
.PD 1
.P
.PD
Parent selction method mask.

.B
	Note
.RS
This is equal to RIGEL_PARAM_SELPROPN|RIGEL_PARAM_SELRANKG|RIGEL_PARAM_SELTOURN.
.RE
.PD 1
.P
.PD







.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_REPRANKG
.PD 0
RIGEL_PARAM_REPRANKG
.PD 1
.P
.PD
Uses ranking as offspring replacement method.




.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_REPTOURN
.PD 0
RIGEL_PARAM_REPTOURN
.PD 1
.P
.PD
Uses tournament as offspring replacement method.




.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_REPLACMT
.PD 0
RIGEL_PARAM_REPLACMT
.PD 1
.P
.PD
Offspring replacement method mask.

.B
	Note
.RS
This is equal to RIGEL_PARAM_REPPROPN|RIGEL_PARAM_REPRANKG|RIGEL_PARAM_REPTOURN.
.RE
.PD 1
.P
.PD







.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_REPCOMMA
.PD 0
RIGEL_PARAM_REPCOMMA
.PD 1
.P
.PD
Uses comma selection for offsprings (exclude elite).




.PD 1
.P
.PD
.SS Macro RIGEL_PARAM_STRATEGY
.PD 0
RIGEL_PARAM_STRATEGY
.PD 1
.P
.PD
Selection and replacement strategies mask.

.B
	Note
.RS
This is equal to RIGEL_PARAM_SELCOMMA|RIGEL_PARAM_REPCOMMA.
.RE
.PD 1
.P
.PD






.SH Parameters store memory management



.PD 1
.P
.PD
.SS Function RIGEL_ParametersAlloc
.PD 0


.I RIGEL_Parameters
.B RIGEL_ParametersAlloc
(
.B 
) ;

.PD 1
.P
.PD
Alllocates a new RIGEL_Parameters structure.

.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else .
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
This constructor initializes all parameters with a zero value.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersCopy
.PD 0


.I RIGEL_Parameters
.B RIGEL_ParametersCopy
(
.I RIGEL_Parameters
.B param
) ;

.PD 1
.P
.PD
Copies a RIGEL_Parameters structure, with its contents.

.B
	Args
.RS
.IP _ 2
.I param
	: parameters set to copy
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else a complete copy of the 'param' argument.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersFree
.PD 0


.I void
.B RIGEL_ParametersFree
(
.I RIGEL_Parameters
.B param
) ;

.PD 1
.P
.PD
Frees a RIGEL_Parameters structure.

.B
	Args
.RS
.IP _ 2
.I param
	: parameters set to free
.IP "" 0
.RE
.PD 1
.P
.PD






.SH Access to hash-stored parameters



.PD 1
.P
.PD
.SS Function RIGEL_ParametersGetHash
.PD 0


.I double
.B RIGEL_ParametersGetHash
(
.I RIGEL_Parameters
.B param
,
.I char
.B *
.B name
) ;

.PD 1
.P
.PD
Get hash-stored parameters from a RIGEL_Parameters structure.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to query
.IP "" 0
.IP _ 2
.I name
	: hash key for the parameter
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
else the (positive) parameter value.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if the parameter set or the hash key were NULL
.IP "" 0
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersSetHash
.PD 0


.I double
.B RIGEL_ParametersSetHash
(
.I RIGEL_Parameters
.B param
,
.I char
.B *
.B name
,
.I double
.B value
) ;

.PD 1
.P
.PD
Set hash-stored parameters in a RIGEL_Parameters structure.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to update
.IP "" 0
.IP _ 2
.I name
	: hash key for the parameter
.IP "" 0
.IP _ 2
.I value
	: a positive value to store
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
else the 'value' argument.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.IP _ 2
.I EINVAL
	: if an argument was invalid
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Only positive 'value' arguments are accepted. If the hash entry for 'name' does not exist, it will be created.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersDelHash
.PD 0


.I double
.B RIGEL_ParametersDelHash
(
.I RIGEL_Parameters
.B param
,
.I char
.B *
.B name
) ;

.PD 1
.P
.PD
Delete hash-stored parameters from a RIGEL_Parameters structure.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to update
.IP "" 0
.IP _ 2
.I name
	: hash key for the parameter
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an error occured
.IP "" 0
else .
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if an argument was invalid
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Attempting to delete a non-existing hash entry will result in a -1 result, but will not set 'errno'.
.RE
.PD 1
.P
.PD






.SH Initialisation and string-based setting of parameters



.PD 1
.P
.PD
.SS Function RIGEL_ParametersSetDefaults
.PD 0


.I RIGEL_Parameters
.B RIGEL_ParametersSetDefaults
(
.I RIGEL_Parameters
.B param
) ;

.PD 1
.P
.PD
Set default parameters in a RIGEL_Parameters structure.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to update (if any)
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if no memory was available
.IP "" 0
else the updated or allocated parameter set.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
If 'param' is null, a new parameter set will be allocated. Any hash-stored parameter in the original 'param' argument is unaffected.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersGetDouble
.PD 0


.I double
.B RIGEL_ParametersGetDouble
(
.I RIGEL_Parameters
.B param
,
.I char
.B *
.B name
) ;

.PD 1
.P
.PD
Get a named parameter in a RIGEL_Parameters structure, as a double value.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to query
.IP "" 0
.IP _ 2
.I name
	: parameter name
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid
.IP "" 0
else the parameter value.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Non-double parameters (integer and flags) will be converted to double. Casting back to the proper type should result in a correct value, however.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersGetString
.PD 0


.I char
.B *
.B RIGEL_ParametersGetString
(
.I RIGEL_Parameters
.B param
,
.I char
.B *
.B name
) ;

.PD 1
.P
.PD
Get a named parameter in a RIGEL_Parameters structure, as a character string.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to query
.IP "" 0
.IP _ 2
.I name
	: parameter name
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if an argument was invalid
.IP "" 0
else a malloc-ed character string representation of the parameter value.
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The flag parameter will be converted to a human-readable flag representation.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersSet
.PD 0


.I unsigned
.I long
.B RIGEL_ParametersSet
(
.I RIGEL_Parameters
.B param
,
.I char
.B *
.B name
,
.I char
.B *
.B val
) ;

.PD 1
.P
.PD
Set a named parameter in a RIGEL_Parameters structure.

.B
	Args
.RS
.IP _ 2
.I param
	: parameter set to update
.IP "" 0
.IP _ 2
.I name
	: parameter name
.IP "" 0
.IP _ 2
.I val
	: parameter value string
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I -1
	: if an argument was invalid
.IP "" 0
.IP _ 2
.I 0
	: if a value was not in the correct range
.IP "" 0
else the original value before the update
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I EINVAL
	: if an argument was invalid
.IP "" 0
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
The value string will be converted to the actual storage type for this parameter. Any unrecognized built-in parameter name will be stored in hash, provided a parameter with this name has already been defined using RIGEL_ParametersSetHash.
.RE
.PD 1
.P
.PD






.SH Argument parsing



.PD 1
.P
.PD
.SS Function RIGEL_ParametersParse
.PD 0


.I void
.B RIGEL_ParametersParse
(
.I RIGEL_Parameters
.B param
,
.B ...
) ;

.PD 1
.P
.PD
Parse and stores a NULL-terminated array of couples of parameter name/value.

.B
	Args
.RS
.IP _ 2
.I param
	: parmeter set to update
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ParametersParseArgs
.PD 0


.I void
.B RIGEL_ParametersParseArgs
(
.I RIGEL_Parameters
.B param
,
.I int
.B *
.B argc
,
.I char
.B *
.B *
.B *
.B argv
) ;

.PD 1
.P
.PD
Parse, store and remove from the argument array '+'-prefixed parameters.

.B
	Args
.RS
param
argc
argv
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_ReadParameters
.PD 0


.I unsigned
.I long
.B RIGEL_ReadParameters
(
.I RIGEL_Parameters
.B param
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Reads and stores parameters lines from a file.

.B
	Args
.RS
param
fd
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if 
.IP "" 0
else .
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Parameters lines are of the form "name = value", where 'name' is the first word (contiguous serie of non-whitespace charaters) on the line before the '=', and 'value' starts at the first non-whitespace character after the '=' until the end of the line.
.RE
.PD 1
.P
.PD





.PD 1
.P
.PD
.SS Function RIGEL_WriteParameters
.PD 0


.I unsigned
.I long
.B RIGEL_WriteParameters
(
.I RIGEL_Parameters
.B param
,
.I int
.B fd
) ;

.PD 1
.P
.PD
Writes parameters lines to a file.

.B
	Args
.RS
param
fd
.RE
.PD 1
.P
.PD


.B
	Returns
.RS
.IP _ 2
.I NULL
	: if 
.IP "" 0
else .
.RE
.PD 1
.P
.PD


.B
	Errors
.RS
.IP _ 2
.I ENOMEM
	: if no memory was available
.IP "" 0
.RE
.PD 1
.P
.PD


.B
	Note
.RS
Parameters lines are of the form "name = value".
.RE
.PD 1
.P
.PD







