#!/usr/bin/perl


################################################################################
###                                                                          ###
###              IN-CONTEXT INTERPRETATION AND REWRITING MODULE              ###
###                                                                          ###
###                                                                          ###
###                               (c) YLS 2000                               ###
###                           landrin@multimania.fr                          ###
###                                                                          ###
###                                                                          ###
################################################################################

# Copyright (c) 2000 YLS, All Rights Reserved.                                 #
# This software  can be redistributed or modified  under the terms  of the GNU #
# General Public License as published by the Free Software Foundation, version #
# 2 or later.                                                                  #
#                                                                              #
# YLS MAKES  NO REPRESENTATIONS  OR WARRANTIES  ABOUT  THE SUITABILITY  OF THE #
# SOFTWARE,  EITHER  EXPRESS  OR  IMPLIED,  INCLUDING  BUT NOT  LIMITED TO THE #
# IMPLIED  WARRANTIES  OF  MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE, #
# OR NON-INFRINGEMENT.  YLS  SHALL  NOT BE LIABLE  FOR ANY DAMAGES SUFFERED BY #
# LICENSEE AS A RESULT OF  USING,  MODIFYING  OR DISTRIBUTING THIS SOFTWARE OR #
# ITS DERIVATIVES.                                                             #
# THIS SOFTWARE  IS  NOT DESIGNED  OR INTENDED  FOR USE  OR RESALE  AS ON-LINE #
# CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE PERFORMANCE, #
# SUCH AS  IN THE  OPERATION  OF NUCLEAR FACILITIES,  AIRCRAFT  NAVIGATION  OR #
# COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE SUPPORT MACHINES, OR #
# WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE SOFTWARE COULD LEAD DIRECTLY TO #
# DEATH,   PERSONAL  INJURY,   OR  SEVERE  PHYSICAL  OR  ENVIRONMENTAL  DAMAGE #
# ("HIGH RISK ACTIVITIES").  YLS SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED #
# WARRANTY OF FITNESS FOR HIGH RISK ACTIVITIES.                                #
#
# VERSION 0.1


package Context ;

BEGIN {
        use Exporter   ();
        use vars       qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);

        $VERSION     = 0.1 ;                                                       
#       $VERSION = do{my@r=q$Revision: 0.1 $=~/\d+/g;sprintf '%d.$trans%02d'x$#r,@r};

        @ISA         = qw(Exporter);
        @EXPORT      = qw();
        @EXPORT_OK   = qw(&InitContext &NextContext &ExitContext);
        %EXPORT_TAGS = ( 'CTX'          => qw!&InitContext &NextContext &ExitContext! ,
                         'HKS'          => qw!$match $trans $start $stop $subs $recsp! ,
                         ) ;

}                                                                             

#use vars qw($qtdel $qiptr $qoptr $verb &MainEval($) &TransL($) &TransR($) );


@blk = () ;
$ctx = undef ;
$match = '' ;
$trans = '.' ;
$start = '<' ;
$stop  = '>' ;
$subs  = '|' ;
$recsp = "\n" ;

$qtdel = '`' ;
$qiptr = '\\' ;
$qoptr = '' ;

$verb  = 0 ;

$TransL = sub { $_ = shift ; $_ =~ tr/\\// ; return $_ ; } ;
$TransR = sub { $_ = shift ; $_ =~ tr//\\/ ; return $_ ; } ;

sub MainEval($) {
	my $ev = shift ;
	my $al = 'qq'.$qtdel.$ev.$qtdel ;
	package main ;
	$al = eval($al) ; warn '``'.$ev.'\'\' '.$@ if $@ ;
	return $al ;
}

sub InitContext($) {
	my $fl = shift ;
	my $tr ;
	my $rs ;
	$qiptr =~ tr/!//d ;
	$qiptr =~ tr/!//d ;
	$qiptr =~ s/\\/\\\\/g ;
	$qoptr =~ s/\\/\\\\/g ;
	$tr = eval('sub { $_ = shift ; $_ =~ tr!'.$qiptr.'!'.$qoptr.'! ; return $_ ; }') ;
	$TransL = $tr unless $@ ;
	$tr = eval('sub { $_ = shift ; $_ =~ tr!'.$qoptr.'!'.$qiptr.'! ; return $_ ; }') ;
	$TransR = $tr unless $@ ;
	$ctx->{$trans} = \@{$fl->{$trans}} ;
	for my $nm (keys(%{$fl})) {
		if(ref($fl->{$nm}) eq 'HASH') {
			$ctx->{$nm}->{$trans} = $fl->{$nm}->{$trans} ;
			$ctx->{$nm}->{$match} = $fl->{$nm}->{$match} ;
			$ctx->{$nm}->{$start} = $TransL->($fl->{$nm}->{$start}) ;
			$ctx->{$nm}->{$stop} = $TransL->($fl->{$nm}->{$stop}) ;
			$ctx->{$nm}->{$subs} = $TransL->($fl->{$nm}->{$subs}) ;
		}
	}
	@blk = () ;
	if(exists $ctx->{$start}) {
		$rs .= MainEval($ctx->{$start}) ;
	}
	return $rs ;
}

sub NextContext($) {
	my $ln = shift ;
	my $rs = '' ;
	if(!defined $ctx) {
		return undef ;
	}
	chomp $ln ;
if($verb>3) { print "**@blk** " ; }
LP:	while(@blk) {
		if(exists $ctx->{$blk[0]}) {
			if(exists $ctx->{$blk[0]}->{$trans}) {
			# Testing for trans maps
			for my $nm (@{$ctx->{$blk[0]}->{$trans}}) {
if($verb>2) { print $nm, '. ' ; }
				if( (exists $ctx->{$nm}) && (exists $ctx->{$nm}->{$match}) && ($ln =~ m/$ctx->{$nm}->{$match}/) ) {
					# We identified nex context in these trans maps
					unshift @blk, $nm ;
if($verb>1) { print $nm, '.>> ' ; }
					if(exists $ctx->{$nm}->{$start}) {
						$rs .= MainEval($ctx->{$nm}->{$start}) ;
					}
					if(exists $ctx->{$nm}->{$subs}) {
						$rs .= MainEval($ctx->{$nm}->{$subs}) ;
					}
					else {
						$rs .= $ln ;
					}
					last LP ;
				}
			}
			}
			# Appliing match substitutions for new context
if($verb>2) { print $blk[0], '.?? ' ; }
			if( (exists $ctx->{$blk[0]}->{$match}) && ($ln =~ m/$ctx->{$blk[0]}->{$match}/) ) {
if($verb>1) { print $blk[0], '.|| ' ; }
				if(exists $ctx->{$blk[0]}->{$subs}) {
					$rs .= MainEval($ctx->{$blk[0]}->{$subs}) ;
				}
				else {
					$rs .= $ln ;
				}
				last LP ;
			}
			elsif(exists $ctx->{$blk[0]}->{$stop}) {
				$rs .= MainEval($ctx->{$blk[0]}->{$stop}) ;
			}
		}
if($verb>2) { print $blk[0], '.VV ' ; }
		shift @blk ;
	} # LP
	# Testing for generic contexts
	if(!scalar(@blk)) {
		for my $nm (@{$ctx->{$trans}}) {
			if( (exists $ctx->{$nm}->{$match}) && ($ln =~ m/$ctx->{$nm}->{$match}/) ) {
				# We got one from the generic contexts
				unshift @blk, $nm ;
if($verb>1) { print $nm, '.<< ' ; }
				if(exists $ctx->{$nm}->{$start}) {
					$rs .= MainEval($ctx->{$nm}->{$start}) ;
				}
				if(exists $ctx->{$nm}->{$subs}) {
					$rs .= MainEval($ctx->{$nm}->{$subs}) ;
				}
				else {
					$rs .= $ln ;
				}
				last ;
			}
		}
	}
if($verb>1) { print $recsp ; }
if($verb) { print $blk[0], '.%% ', $ln, $recsp ; }
	if(length($rs)) {
		$rs = $TransR->($rs).$recsp ;
		return $rs ;
	}
	return '' ;
}

sub ExitContext() {
	my $rs = '' ;
	if(!defined $ctx) {
		return undef ;
	}
	while(@blk) {
		if(exists $ctx->{$blk[0]}->{$stop}) {
			$rs .= MainEval($ctx->{$blk[0]}->{$stop}).$recsp ;
		}
                shift @blk ;
	}
	if(exists $ctx->{$stop}) {
		$rs .= MainEval($ctx->{$stop}) ;
	}
	undef $ctx ;
	$rs = $TransR->($rs) ;
	$TransL = sub { $_ = shift ; $_ =~ tr/\\// ; return $_ ; } ;
	$TransR = sub { $_ = shift ; $_ =~ tr//\\/ ; return $_ ; } ;
	return $rs ;
}



1;
